package de.jg_cody.Teraplex.ui.terminal;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.Vibrator;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.EditorInfo;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;

import java.util.Objects;

import de.jg_cody.Teraplex.R;

public class TerminalFragment extends Fragment {

    public static String command;

    Button send_button;
    EditText terminal_edit_text;
    TextView terminal_textView;
    Terminal terminal;
    ScrollView scrollView;
    public static String user, password, ip;

    private TerminalViewModel terminalViewModel;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        terminalViewModel =
                new ViewModelProvider(this).get(TerminalViewModel.class);
        View root = inflater.inflate(R.layout.fragment_terminal, container, false);
        SharedPreferences prefs = requireContext().getSharedPreferences("appsettings", Context.MODE_PRIVATE);
        user = prefs.getString("user", null);
        password = prefs.getString("password", null);
        ip = prefs.getString("ip", null);
        if (user == null || ip == null || password == null) {
            AlertDialog mDialog = new AlertDialog.Builder(getContext())
                    .setTitle(getString(R.string.unable_to_connect))
                    .setMessage(getString(R.string.please_login))

                    // Specifying a listener allows you to take an action before dismissing the dialog.
                    // The dialog is automatically dismissed when a dialog button is clicked.
                    .setPositiveButton(getString(R.string.ok), new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialogInterface, int i) {
                            Vibrator vr = (Vibrator) requireContext().getSystemService(Context.VIBRATOR_SERVICE);
                            assert vr != null;
                            vr.vibrate(100);
                        }
                    }).create();
            Objects.requireNonNull(mDialog.getWindow()).setBackgroundDrawableResource(R.drawable.button_round);
            mDialog.getWindow().getAttributes().windowAnimations = R.style.DialogAnimation; //style id
            mDialog.show();

        }
        else {
            Toast.makeText(getContext(), ("test"), Toast.LENGTH_SHORT).show();
            scrollView = (ScrollView) root.findViewById((R.id.scrollView));
            terminal_edit_text = (EditText) root.findViewById(R.id.terminal_edit_text);
            send_button = (Button) root.findViewById(R.id.send_button);
            send_button.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {

                        if (terminal != null) {
                            terminal.sendTerminalCommand(terminal_edit_text.getText().toString());
                        }

                }

            });
            terminal_edit_text.setOnEditorActionListener(new EditText.OnEditorActionListener() {
                @Override
                public boolean onEditorAction(final TextView v, final int actionId, final KeyEvent event)
                {
                    boolean handled=false;

                    // Some phones disregard the IME setting option in the xml, instead
                    // they send IME_ACTION_UNSPECIFIED so we need to catch that
                    if(EditorInfo.IME_ACTION_DONE==actionId || EditorInfo.IME_ACTION_UNSPECIFIED==actionId)
                    {
                        if (terminal != null) {
                            terminal.sendTerminalCommand(terminal_edit_text.getText().toString());
                        }

                        handled=true;
                    }

                    return handled;
                }
            });
            terminal_textView = (TextView) root.findViewById(R.id.terminal_textView);
            new Thread() {
                public void run() {
                    terminal = new Terminal();
                    requireActivity().runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            Toast.makeText(getContext(),"VERBUNDEN", Toast.LENGTH_SHORT).show();
                        }
                    });
                    boolean isFragmentActive = true;
                    while (isFragmentActive) {
                        Fragment myFragment = (Fragment) requireActivity().getSupportFragmentManager().findFragmentById(R.id.fragment_terminal);
                        if (myFragment == null) {

                            isFragmentActive = false;
                        }
                        else if (myFragment.isVisible())
                        {
                            isFragmentActive = false;
                        }

                        try {
                            requireActivity().runOnUiThread(new Runnable() {

                                @Override
                                public void run() {
                                    boolean atBottom = scrollView.getChildAt(0).getBottom() <= (scrollView.getHeight() + scrollView.getScrollY());
                                    terminal_textView.setText(terminal.getTerminalOutput());
                                    System.out.println(atBottom);

                                    terminal_textView.invalidate();
                                    scrollView.invalidate();
                                    scrollView.fullScroll(View.FOCUS_DOWN);

                                }
                            });
                            Thread.sleep(250);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
            }.start();
        }


        return root;
    }


    @Override
    public void onDestroy() {
        if (terminal != null) {
            terminal.closeTerminal();
        }
        super.onDestroy();
    }


}